var bIsDev = false;

var strAppName = 'Diabetes-Friendly Recipes from SparkPeople';
var strAppNameShort = 'SP_DIABETES_RECIPES';
var strOKMessage = "OK";

/*******************************************SECTION THAT IS COMMON TO EVERY PROJECT*******************************************/
var db;

var seed = days_between(new Date(), new Date('1/3/2014'));
function random() {
    var x = Math.sin(seed++) * 10000;
    return x - Math.floor(x);
}


function isAndroid()
{
	return navigator.userAgent.match(/(Android)/);
}

function isIOS()
{
	return navigator.userAgent.match(/(iPhone|iPod|iPad)/);
}

function isWP()
{
	return navigator.userAgent.match(/(IEMobile)/);
}

function getPlatform()
{
	if (isAndroid())
	{
		return 'android';
	}
	if (isIOS())
	{
		return 'ios';
	}
	if (isWP())
	{
		return 'wp';
	}

}

function gotoContentSection(oSection, oOptions)
{
	$( ":mobile-pagecontainer" ).pagecontainer( "change", oSection, oOptions);
	return false;
}

function doMenu(strMenu)
{
	$(strMenu).panel("open");
}

function getContentFromFile(strFile, functionCall)
{
	ga_storage._trackPageview('' + strFile, strFile + ' - ' + getPlatform());

	$.ajax({
        url : strFile,
        type : "get",
        success : function(data, textStatus, jqXHR) {
            functionCall(data);
        },
        error : function(jqXHR, textStatus, errorThrown) {
			$.ajax({
				url : 'www/' + strFile,
				type : "get",
				success : function(data, textStatus, jqXHR) {
					functionCall(data);
				},
				error : function(jqXHR, textStatus, errorThrown) {
					console.log('error loading data from ' + strFile + ':' + errorThrown);
					functionCall("");
				}
			});
        }
    });
}

function fillObjectWithContentFromFile(strObj, strFile)
{
	getContentFromFile(strFile, function(strReturn){
		$(strObj).html(strReturn);
	});
}

function gotoContentSectionSimple(strSection)
{
	return gotoContentSection(strSection, {transition: 'none', allowSamePageTransition: true});
}



function consoleLog(strParm)
{
	if(bIsDev)
		console.log(strParm);
}

function spAppAlert(strParm)
{
	if(bIsDev)
		alert(strParm);
}

function bSupportsNotification()
{
	if(window)
		if(window.plugin)
			if(window.plugin.notification)
				return true;
				
	return false;
}

function getDateWithHour(dateParam, iHour, iMinute)
{
	var dateReturn =  new Date(dateParam.getFullYear(), dateParam.getMonth(), dateParam.getDate(), iHour, iMinute, 0, 0);
	return dateReturn;
}

function days_between(date1, date2) {

	var oneDay = 24*60*60*1000; // hours*minutes*seconds*milliseconds
	var firstDate = new Date(date1);
	var secondDate = new Date(date2);

	var diffDays = Math.round(((firstDate.getTime() - secondDate.getTime())/(oneDay)));
	return diffDays;
}

function strDBName()
{
	return strAppNameShort + "_DB";
}

function successHandler(strParm){
	consoleLog("SQL Query Succeeded - " + strParm);
}

function errorHandler(transaction, error){
 	if (error.code==1){
 		consoleLog('Table already created.');
 	} else {
    	// Error is a human-readable string.
	    consoleLog('Oops.  Error was '+error.message+' (Code '+error.code+')');
 	}
    return false;
}


function validateEmail(email) { 
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
} 

function SendInfoToSP(info)
{
	try
	{
		if (navigator.connection)
		{
			if(navigator.connection.type != Connection.NONE)
			{
				var strInfo = '';
				if(device)
				{
					strInfo += 'app=' + strAppNameShort + '&'
					strInfo += 'dn=' + device.name + '&';
					strInfo += 'dc=' + device.cordova + '&';
					strInfo += 'dp=' + device.platform + '&';
					strInfo += 'dv=' + device.version + '&';
					strInfo += 'uuid=' + device.uuid + '&';
				}
				$.ajax({   
					type: "GET",   
					url: strSPInfoReceiver,  
					timeout: 30000, 
					data: strInfo + info,   
				});
			}
		}
		
	}
	catch (ex)
	{
		consoleLog("unable to send info to sp");
	}
}

function fixAdIFrame(strFrame)
{
	$(strFrame).one('load', function() {
		makeOpenWindowHref(strFrame);
	});
}

function bIsDevice()
{
	consoleLog("in bisdevice. url=" + document.URL + " val=" + document.URL.match(/(sparkrecipes)/))
	return !document.URL.match(/(sparkrecipes)/);
}

function makeOpenWindowHref(element) {
	if (bIsDevice()){
		$(element).contents().find('a[href^="http"]').each(function() {
		   $(this).click(function(event){
				event.preventDefault();
				window.open($(this).attr("href"), '_system');
			});
		});
	}
}

function goToApp(x) {
	var strURL = "";
	if (isIOS())
	{
		switch (x)
		{
			case 1:
				strURL = "https://itunes.apple.com/us/app/healthy-recipes-by-sparkrecipes/id341637587";
				break;
			case 2:
				strURL = "https://itunes.apple.com/us/app/inspirational-quote-day-by/id490681452"; 
				break;
			case 3:
				strURL = "https://itunes.apple.com/us/app/sparkcoach/id648377670"; 
				break;
			case 4:
				strURL = "https://itunes.apple.com/us/app/perfect-produce-by-sparkpeople/id427975348"; 
				break;
			case 5:
				strURL = "https://itunes.apple.com/us/app/calorie-counter-weight-loss/id568471693"; 
				break;
		}
	}
	else if (isAndroid())
	{
		switch (x)
		{
			case 1:
				strURL = "market://details?id=com.sparkpeople.android.cookbook";
				break;
			case 2:
				strURL = "market://details?id=com.sparkpeople.android.qotd"; 
				break;
			case 3:
				strURL = "market://details?id=com.sparkpeople.android.sparkcoach"; 
				break;
			case 4:
				strURL = "market://details?id=com.sparkpeople.android.produce"; 
				break;
			case 5:
				strURL = "market://details?id=com.sparkpeople.androidtracker"; 
				break;
			}
	}
	else if (isWP())
	{
		switch (x)
		{
			case 1:
				strURL = "http://recipes.sparkpeople.com";
				break;
			case 2:
				strURL = "http://www.sparkpeople.com"; 
				break;
			case 3:
				strURL = "http://www.sparkcoach.com"; 
				break;
			case 4:
				strURL = "http://recipes.sparkpeople.com"; 
				break;
			case 5:
				strURL = "http://www.sparkpeople.com"; 
				break;
			}
	}
	if (strURL != "")
	{
		goToURL(strURL);
	}
}


function goToURL(strURL)
{
	ga_storage._trackPageview(strURL,'Clicked on External URL ' + ' - ' + getPlatform());
	window.open(strURL, '_system');
}